<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8">
    <link href="https://brendan.ie/main.css" rel="stylesheet">

    <title>UL Timetable</title>

    <meta content="UL ical" name="title">
    <meta content="Brendan Golden" name="author">
    <meta content="Instantly get an ical of yer timetable for Outlook" name="description">

    <!-- for mobile devices -->
    <meta content="width=device-width,initial-scale=1" name="viewport">

    <!-- brendan.coffee -->
    <link href="https://brendan.ie/coffee/coffee.css" rel="stylesheet">
    <script src="https://brendan.ie/coffee/coffee.js"></script>
  </head>
  <body class="sticky-wrapper">
    <div id="coffee_anchor"><span id="served"></span></div>
    <script>C0FFEE()</script>
    <header>
      <h1>Brendan's UL Timetable</h1>
    </header>
    <main>
      <p>
        This tool will get you timetable and convert it into a file that can be imported into Outlook.
        <br/>
        Comes colour coded.

        <br/>
        <br/>
        The UL timetable may change between now and when you start college so you may have to update it.
        <br/>
        <br/>
        Instructions, desktop recommended:
      </p>


      <ol>
        <li>Go to <a href="https://timetable.ul.ie/UA/Default.aspx" rel="noopener noreferrer" target="_blank">https://timetable.ul.ie/UA/Default.aspx</a>
        </li>
        <br/>

        <li>Login</li>
        <br/>

        <li>Press F12 (Some laptops may require teh function key to be pressed with F12)</li>
        <br/>

        <li>Go to:
          <ul>
            <li>Storage (Firefox)</li>
            <li>Application (Chrome)</li>
            <li>Application (Edge)</li>
          </ul>
        </li>
        <br/>

        <li>Cookies</li>
        <br/>

        <li>timetable.ul.ie</li>
        <br/>

        <li>There will be a list of items, you will need to find the two listed below and put them into the boxes.</li>
        <br />

        <li>
          <form method="get">
            <!-- lecturers have a different link -->
            <label for="type">Student or lecturer: </label>
            <select id="type" required>
              <option value="student" selected>Student</option>
              <option value="lecturer" disabled>Lecturer</option>
            </select>

            <label for="codes">Module codes or names: </label>
            <select id="codes" required>
              <option value="code" >Code - Lec</option>
              <option value="name" >Name - Lec</option>
              <option value="both" selected>Code (Name) - Lec</option>
            </select>

            <label for="reminder_toggle">Reminders of events: </label>
            <select id="reminder_toggle" required onchange="toggleRemainderTime()">
              <option value="no" selected>No</option>
              <option value="yes" >Yes</option>
            </select>

            <div id="reminder_time_container" hidden>
              <label for="reminder_time">Time of reminder: </label>
              <select id="reminder_time">
                <option value="5">5</option>
                <option value="10" selected>10</option>
                <option value="15">15</option>
                <option value="20">20</option>
                <option value="25">25</option>
                <option value="30">30</option>
              </select>
            </div>

            <label for="session_id">ASP.NET_SessionId: </label>
            <input id="session_id" name="session_id" required size="50" type="text">

            <label for="forms_auth">.ASPXFORMSAUTH: </label>
            <input id="forms_auth" name="forms_auth" required size="50" type="text">

            <label for="submit"></label>
            <input id="submit"  onclick="sendData()" type="button" value="Get Timetable">
          </form>
        </li>
        <br/>

        <li>If there is an error it will appear in red below with possible solutions</li>
        <br/>

        <li>If a file downloaded drag it into outlook and</li>
        <br/>

        <li>If your timetable changes you may need to redo the process</li>
        <br/>
      </ol>
      <br/>
      <span id="info" style="color: red;font-size: 40px;"></span>

      <hr/>
      <br/>

      <p>
        Previously UL had a different timetable setup where you just entered your ID and got your timetable.
        <br/>
        In this period there were many tools that parsed the timetable, sadly due to a new enforced login their tools no
        longer work

      </p>
      <ul>
        <li>
          <a href="https://github.com/DownCastAce/timetable_scraper" rel="noopener noreferrer" target="_blank">
            DownCastAce/timetable_scraper
          </a>
        </li>
        <li>
          <a href="https://github.com/eoin-obrien/ul-timetable-api" rel="noopener noreferrer" target="_blank">
            eoin-obrien/ul-timetable-api
          </a>
        </li>
        <li>
          <a href="https://github.com/stephenfin/ul-ical-generator" rel="noopener noreferrer" target="_blank">
            stephenfin/ul-ical-generator
          </a>
        </li>
      </ul>
    </main>
    <footer>
        <span>
          <a href="https://gitlab.com/c2842/misc/ul_timetable_ical" rel='noopener noreferrer' target='_blank'>
            API source.
          </a> | <wbr/>
          <a href="https://www.youtube.com/playlist?list=PLqkGLflSxfVHKVrcB9ic0fs23gw4Vygig" rel="noopener noreferrer" target="_blank">
            Playlist of dev this page
          </a> | <wbr/>
          <a href="https://gitlab.com/brendan.ie/v1/-/blob/main/src/timetable/calendar.html" rel="noopener noreferrer" target="_blank">
            Code of this page
          </a>
        </span>
      <br/>
      <br/>
      <span>
          © 2021-<span id="year">2021</span> | <wbr/>
          Brendan Golden | <wbr/>
          Email: contact_me(at symbol)brendan.ie <a href="mailto:contact_website@brendan.ie"></a><a href="mailto:contact@brendan.ie"></a>  | <wbr/>
          Gitlab: <a href="https://gitlab.com/Brendan_Golden">Brendan_Golden</a> | <wbr/>
          Discord: Silver#5563 | <wbr/>
          Mastodon: <a rel="me" href="https://mastodon.brendan.ie/@silver">@silver</a>
        </span>
    </footer>

    <script>
      /* I am a lazy fucker */
      document.getElementById('year').textContent = new Date().getFullYear().toString()
    </script>
    <script>
      function toggleRemainderTime(){
        let container = document.getElementById('reminder_time_container');
        container.hidden = !container.hidden;
      }

      async function sendData () {
        let url = `https://api.brendan.ie/timetable/calendar`+
          `?ical_session_id=${document.getElementById('session_id').value}`+
          `&ical_forms_auth=${document.getElementById('forms_auth').value}`+
          `&ical_type=${document.getElementById('type').value}`+
          `&ical_codes=${document.getElementById('codes').value}`+
          `&ical_reminder_toggle=${document.getElementById('reminder_toggle').value}`+
          `&ical_reminder_time=${document.getElementById('reminder_time').value}`

        await fetch(url)
          // get the data
          .then(async (response) => {
            if (response.status === 400) {
              document.getElementById(`info`).innerText = await response.text()
            }
            if (response.status === 204) {
              document.getElementById(`info`).innerText = 'Either no classes or invalid details or week data is not yet available.'
            }

            return response.blob()
          })
          // https://stackoverflow.com/a/9834261/11964934
          .then(blob => {
            if (blob.size === 0) {
              return
            }

            // looks like this creates an invisible link then clicks it
            const url = window.URL.createObjectURL(blob)
            const a = document.createElement('a')
            a.style.display = 'none'
            a.href = url
            a.download = 'brendan.ie_ul_calendar.ics'
            document.body.appendChild(a)
            a.click()
            window.URL.revokeObjectURL(url)

          }).catch((err) => console.log(err))
      }
    </script>
  </body>
</html>